#!/usr/bin/perl

use strict;

$| = 1;

my $inputline="";

#  my $szs_output="";  # Model, Proof
#  my @output;  # pripadny vystup (asi jen pri countersat.)
  my $szs_vec="";   # vector of answers (TCGO- for Theorem, CounterSatisfiable, GaveUp, TimeOut, n/a)
  my $szs_status="";   # Theorem, CounterSatisfiable, GaveUp, TimeOut

# READ HEADER
  my $name=read_mathematica_inline();   # file name
  my $orig_status=read_mathematica_inline();
  my $orig_rating=read_mathematica_inline();
  my $t_pure=read_mathematica_inline();
  my $types=read_mathematica_inline();
  print "Problem name: $name\n";
  if ($orig_status ne "") { print "TPTP status $orig_status\n"; };
  if ($orig_rating ne "") { print "TPTP rating $orig_rating\n"; };
  if ($t_pure ne "") { print "Domain $t_pure\n"; };
  if ($types ne "") { print "Uninterpreted symbols $types\n"; };
  print "\n";
  
  if (read_mathematica_inline() =~ /ERROR(.*)/) { $szs_status="GaveUp"; print "ERROR in tfa2math: $1\n"; } else {
  
# READ ANSWERS
  my $x=read_mathematica_inline();
  $x=read_mathematica_outline();  
  print "$x\n";  # flaG
  $x=read_mathematica_inline(); 
  if ($x =~ /^VOID/) { print "\n"; } 
   else { $x=read_mathematica_outline(); print "$x\n\n"; };  # flaP 
  
  $szs_vec.=process_result("Reduce","^True\$","^False\$");
  $szs_vec.=process_result("FullSimplify.%","^True\$","^False\$");
  $szs_vec.=process_result("Reduce.Neg.%","^False\$","^True\$");
  $szs_vec.=process_result("Reduce.Neg","^False\$","^True\$");
  $szs_vec.=process_result("FullSimplify.%","^False\$","^True\$");
  $szs_vec.=process_result("Reduce.Neg.%","^True\$","^False\$");

  print "\n";$szs_vec.=" ";

  $szs_vec.=process_result("FullSimplify","^True\$","^False\$");
  $szs_vec.=process_result("Reduce.%","^True\$","^False\$");
  $szs_vec.=process_result("FindInstance.%","->","^{}");
  $szs_vec.=process_result("FullSimplify.Neg","^False\$","^True\$");
  $szs_vec.=process_result("Reduce.%","^False\$","^True\$");
  $szs_vec.=process_result("FindInstance.%","^{}","->");
  
  print "\n";$szs_vec.=" ";

  $szs_vec.=process_result("Reduce/dom","^True\$","^---\$");  # misto --- by bylo False, kdyby Mathematica fungovala spravne
  $szs_vec.=process_result("Reduce/dom.Neg.%","^---\$","^True\$");
  $szs_vec.=process_result("Reduce/dom.Neg","^---\$","^True\$");
  $szs_vec.=process_result("Reduce/dom.Neg.%","^True\$","^---\$");
  
  print "\n";$szs_vec.=" ";

  $szs_vec.=process_result("FindInstance/dom","->","^{}");
  $szs_vec.=process_result("FindInstance/dom.Neg","^{}","->");
  
  print "\n";$szs_vec.=" ";

  $szs_vec.=process_result("Reduce","^True\$","^False\$");
  $szs_vec.=process_result("Reduce.Neg","^False\$","^True\$");

# PRODUCE SZS STATUS
  tisk:
  print "\nSZS vector $szs_vec\n";
  $szs_status="GaveUp";
  if ($szs_vec =~ /O/) { $szs_status="TimeOut"; };
  if ($szs_vec =~ /C/) { $szs_status="CounterSatisfiable"; };
  if ($szs_vec =~ /T/) { $szs_status="Theorem"; };
  if ($szs_vec =~ /T/ && $szs_vec =~ /C/) { $szs_status="GaveUp"; print "!!! ERROR System unsound. Contradicting answers.\n"; };

}


# PRINT OUTPUT
  print "\n% SZS status $szs_status for $name\n";
 # if ($szs_output ne "") {
 #   print "% SZS output start $szs_output for $name\n";
 #   print @output;
 #   print "% SZS output end $szs_output for $name\n";
 #  };
   
  if ($szs_status eq "Theorem" && $orig_status eq "CounterSatisfiable") { print "!!! ERROR System unsound. Answer contradicts status.\n"; };
  if ($orig_status eq "Theorem" && $szs_status eq "CounterSatisfiable") { print "!!! ERROR System unsound. Answer contradicts status.\n"; };



sub process_result {
  my $name=shift(@_);
  my $s_thm=shift(@_);
  my $s_csa=shift(@_);
  
  my $x=read_mathematica_inline();
  if ($x =~ /^VOID/) { return "-"; } 
    else {
		my $x=read_mathematica_outline();
		print "$name says: $x\n";
		if ($x =~ $s_thm) { return "T"; }
			elsif ($x =~ $s_csa) { return "C"; } 
			elsif ($x =~ /\$Aborted/) { return "O"; }
			else  { return "G"; };
		};	
}



sub read_mathematica_inline {

 while (!($inputline =~ /^In\[\d*\]/))
	{ if (!($inputline=<STDIN>)) { goto tisk; } };
 $inputline =~ /^In\[\d*\]:= (.*)$/; my $x=$1;
 chomp($x);
 while ($x =~ /(.*)\\\s*$/)
  { 
   $x=$1;
   <STDIN>;
   my $y=<STDIN>;
   chomp($y);
   $x.=substr($y,4,length($y)-4);
  }
 $inputline="";
 return $x;
}


sub read_mathematica_outline {

 while (!(($inputline =~ /^In\[\d*\]/) || ($inputline =~ /^Out\[\d*\]/)))
	{ if (!($inputline=<STDIN>)) { goto tisk; } };
 if ($inputline =~ /^In/) { return ""; };  # no output line
 $inputline =~ /^Out\[\d*\][^=]*= (.*)$/; my $x=$1;
 chomp($x);
 if ($x eq "") {
   my $y;
   do {
     if (!($y=<STDIN>)) { goto tisk; };
	 chomp($y);
	 $x.=$y;
	} until ($y eq "");
  }
 $inputline=""; 
 return $x;
}
